{==============================================================================|

| Project : JP WinPing

|==============================================================================|

| Project version : 1.0

|==============================================================================|

| Content : 

|==============================================================================|

| Author : Jiri Provaznik

|==============================================================================|

| URL : http://www.provaz.cz/sector02

|==============================================================================|

| Copyright: 

|  The Initial Developer of the Original Code is Jiri Provaznik 

|  (Czech Republic). Copyright (C) 2003. All Rights Reserved.

|==============================================================================|

| History: 

|  1.0 - Single ping

|==============================================================================}

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, IdBaseComponent, IdComponent, IdRawBase,
  IdRawClient, IdIcmpClient, ExtCtrls, ComCtrls, Spin;

type
  TForm1 = class(TForm)
    IdIcmpClient: TIdIcmpClient;
    ListView1: TListView;
    StatusBar1: TStatusBar;
    Panel1: TPanel;
    BitBtn1: TBitBtn;
    eHost: TEdit;
    Label1: TLabel;
    SpinEdit1: TSpinEdit;
    Label2: TLabel;
    BitBtn2: TBitBtn;
    procedure BitBtn1Click(Sender: TObject);
    procedure IdIcmpClientReply(ASender: TComponent;
      const AReplyStatus: TReplyStatus);
    procedure BitBtn2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
  IdIcmpClient.ReceiveTimeout := SpinEdit1.Value;
  IdIcmpClient.Host := eHost.Text;
  IdIcmpClient.Ping();
end;

procedure TForm1.IdIcmpClientReply(ASender: TComponent;
  const AReplyStatus: TReplyStatus);
var
  s: string;
  aListItem : TListItem;
begin
  aListItem := ListView1.Items.Insert(0);
  with aListItem do
  begin
    Caption := AReplyStatus.FromIpAddress;
    SubItems.Add(IntToSTr(AReplyStatus.BytesReceived));
    SubItems.Add(IntToStr(AReplyStatus.MsgType));
    SubItems.Add(IntToStr(AReplyStatus.SequenceId));
    SubItems.Add(IntToStr(AReplyStatus.MsRoundTripTime));
    SubItems.Add(IntToStr(AReplyStatus.TimeToLive));

    s:= 'No Status';
    Case  AReplyStatus.ReplyStatusType of
      rsEcho             : s:= 'rsEcho';
      rsError            : s:= 'rsError';
      rsTimeOut          : s:= 'rsTimeOut';
      rsErrorUnreachable : s:= 'rsErrorUnreachable';
      rsErrorTTLExceeded : s:= 'rsErrorTTLExceeded';
    end;

    SubItems.Add(s);
  end;
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
  ListView1.Clear;
end;

end.
